// asio_server.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <boost/asio.hpp>
#include <boost/make_shared.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/thread.hpp>
#include "asio_server.h"

boost::asio::io_service io_service;
boost::asio::io_service::work work(io_service);

#if defined(_MSC_VER)
using asio_tp = boost::asio::ip::tcp;
const asio_tp::endpoint ep(boost::asio::ip::tcp::v4(), 4444);
#else
using asio_tp = boost::asio::local::stream_protocol;
const std::string uds_path("/Users/Enji/760ed723-d550-45fa-8f54-dde5033ce459");
const asio_tp::endpoint ep(uds_path);
#endif

boost::shared_ptr<asio_tp::acceptor> acceptor = nullptr;
std::vector<unsigned char> buffer(1024 * 6);

long long count = 0;

void handle_read(boost::shared_ptr<asio_tp::socket> socket,
	const boost::system::error_code& ec,
	std::size_t bytes_transferred)
{
	if (ec)
	{
		std::cout << "errored : " << ec.message() << ". in " << __func__ << std::endl;
//        if (acceptor->is_open())
//        {
//            boost::system::error_code ec;
//            acceptor->cancel(ec);
//            acceptor->close(ec);
//        }
//
//        acceptor = nullptr;
		do_accept();
		return;
	}

	socket->async_read_some(
		boost::asio::buffer(buffer),
		boost::bind(
			handle_read,
			socket,
			boost::asio::placeholders::error,
			boost::asio::placeholders::bytes_transferred));

	std::cout << count++ << std::endl;
}

void handle_accept(
    boost::shared_ptr<asio_tp::acceptor> acceptor,
    boost::shared_ptr<asio_tp::socket> socket,
	const boost::system::error_code& ec)
{
	if (ec)
	{
		std::cout << "errored : " << ec.message() << ". in " << __func__ << std::endl;
        
//        if (acceptor->is_open())
//        {
//            boost::system::error_code ec;
//            acceptor->cancel(ec);
//            acceptor->close(ec);
//        }
//
//        acceptor = nullptr;
        do_accept();

        return;
	}

	socket->async_read_some(
		boost::asio::buffer(buffer),
		boost::bind(
			handle_read, 
			socket, 
			boost::asio::placeholders::error, 
			boost::asio::placeholders::bytes_transferred));
}

void do_accept()
{
	auto socket = boost::make_shared<asio_tp::socket>(io_service);
    if (acceptor == nullptr)
    {
        acceptor = boost::make_shared<asio_tp::acceptor>(io_service);

        acceptor->open(ep.protocol());
        acceptor->set_option(asio_tp::acceptor::reuse_address(true));
    //    acceptor->set_option(asio_tp::acceptor::enable_connection_aborted(true));
        acceptor->bind(ep);
        acceptor->listen();
    }
    
    acceptor->async_accept(
		*socket, 
		boost::bind(
			handle_accept,
			acceptor,
			socket, 
			boost::asio::placeholders::error));
}

int main()
{
	boost::thread io_thread([]() {io_service.run(); });

	do_accept();

	io_thread.join();
    return 0;
}

